/**
 * Define the exit command.
 */

package extensions.generic;

import extensions.generic.*;
import java.awt.*;
import java.util.HashMap;
import java.util.Vector;
import javax.media.j3d.*;
import javax.vecmath.*;

public class TransCmd implements Command {
	private HashMap axisData;
	private List list;
	private Label label;
	private int MODE;
	private boolean Normal_mode;
	private int Numberofappl;
	private HashMap[] molecules;
    private TextField transX;
    private TextField transY;
    private TextField transZ;	
	
	public TransCmd(List list, Label label, int MODE, int Numberofappl,
	            HashMap[] molecules, TextField transX, TextField transY,
	            TextField transZ, boolean Normal_mode) {
		this.list = list;
		this.label = label;
		this.MODE = MODE;
		this.Numberofappl = Numberofappl;
		this.molecules = molecules;
		this.transX = transX;
		this.transY = transY;
		this.transZ = transZ;
		this.Normal_mode = Normal_mode;
	}
		
    public void Execute(){
    	
    	String items[] = list.getSelectedItems();
	    if(!Normal_mode) {
           label.setText("Mode: Translate");
           MODE = 1; //TRANSLATE 

           for( int i = 0; i < items.length; i++ ){
              System.out.println("Translate item: " + items[i]);
              doTransformText(items[i]);
           }
         } else {
     	        System.out.println("It has the Normal Mode!!!");
     	        return;  }	 

    }

    private void doTransformText(String name){

     TransformGroup tg = new TransformGroup();
     setCapabilities(tg);
     HashMap molecule_tmp = new HashMap();

     if( name == null )
       return;

  	  for(int i=0; i<Numberofappl; i++)
	    if(((String)molecules[i].get("MOLECULE_ID")).equals(name)) {
           tg = (TransformGroup)molecules[i].get(name);
           molecule_tmp = molecules[i];
           break;
        }     

	 int mnvertex = ((Integer)molecule_tmp.get("nvertex")).intValue();
	 int mcylindercount = ((Integer)molecule_tmp.get("cylindercount")).intValue();
	 
     int totaltg = mnvertex + mcylindercount; //+4;
     TransformGroup tgarray[] = new TransformGroup[totaltg];

	 System.out.println("Totaltg: "+totaltg);

     Transform3D t3d = new Transform3D();
     Transform3D t3darray[] = new Transform3D[totaltg];

     for(int i = 0; i<totaltg; i++) {
        tgarray[i] = new TransformGroup();
        setCapabilities(tgarray[i]);
     }   

	 Vector atomsofmolecule = new Vector();
	 atomsofmolecule = (Vector)molecule_tmp.get("atom");
	 int numofatom = atomsofmolecule.size();
	 for(int i=0; i<numofatom; i++)
	    tgarray[i] = (TransformGroup)molecule_tmp.get((String)atomsofmolecule.elementAt(i));

     for(int i = 1; i<=mcylindercount; i++) {
         String tmp = "Cylindername"+i;
	     tgarray[i+numofatom-1] = (TransformGroup)molecule_tmp.get(tmp);
     }

     tg.getTransform( t3d );
     for(int j=0; j<totaltg; j++) {
          t3darray[j] = new Transform3D();
          tgarray[j].getTransform( t3darray[j] );
     }

     Vector3d v = new Vector3d();     	           	
     Vector3d varray[] = new Vector3d[totaltg];
	 t3d.get( v );

	 for(int k=0; k<totaltg; k++) {
         varray[k] = new Vector3d();
	     t3darray[k].get( varray[k] );
     }
            
     t3d.setTranslation( 
        new Vector3d(v.x + Double.parseDouble(transX.getText().trim()),
                     v.y + Double.parseDouble(transY.getText().trim()),
              	     v.z + Double.parseDouble(transZ.getText().trim())));

	 for(int l=0; l<totaltg; l++)
       t3darray[l].setTranslation( 
         new Vector3d( varray[l].x + Double.parseDouble(transX.getText().trim()),
                       varray[l].y + Double.parseDouble(transY.getText().trim()),
                 	   varray[l].z + Double.parseDouble(transZ.getText().trim())));

    tg.setTransform( t3d );
    for(int m=0; m<totaltg; m++)
        tgarray[m].setTransform( t3darray[m] );

  }

  private void setCapabilities(TransformGroup tg) 
  {
     tg.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
     tg.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
     tg.setCapability(Group.ALLOW_CHILDREN_WRITE);
     tg.setCapability(Group.ALLOW_CHILDREN_READ);
     tg.setCapability(Group.ALLOW_CHILDREN_EXTEND);
     tg.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
  } 


}

